
#include <intuition/preferences.h>

/****** Turboprint **********/

#define MYMATCHWORD    0xf10a57ef
#define MYMATCHVERSION 0x80000007
#define MYBADDR(bptr) (((ULONG)bptr)<<2)

struct ExtDMPRPort 
	{
	UWORD PixAspX; UWORD PixAspY; 
	UWORD GraphMode;
	APTR BitMap1; APTR BitMap2; APTR BitMap3;
	APTR BitMap4; APTR BitMap5; APTR BitMap6;
	APTR BitMap7; APTR BitMap8;
	UWORD BytesPerRow; UWORD XOffset;
	};

#define PPC_COPIES 32 /* printer can print copies */
#define PPC_MARGINS 128 /* printer driver specifies margins */

struct PrinterExtendedDataTP 
	{
	char	*ped_PrinterName;    /* printer name, null terminated */
	VOID	(*ped_Init)(void);	     /* called after LoadSeg */
	VOID	(*ped_Expunge)(void);    /* called before UnLoadSeg */
	int	(*ped_Open)(void);	     /* called at OpenDevice */
	VOID	(*ped_Close)(void);      /* called at CloseDevice */
	UBYTE	ped_PrinterClass;    /* printer class */
	UBYTE	ped_ColorClass;      /* color class */
	UBYTE	ped_MaxColumns;      /* number of print columns available */
	UBYTE	ped_NumCharSets;     /* number of character sets */
	UWORD	ped_NumRows;	     /* number of 'pins' in print head */
	ULONG	ped_MaxXDots;	     /* number of dots max in a raster dump */
	ULONG	ped_MaxYDots;	     /* number of dots max in a raster dump */
	UWORD	ped_XDotsInch;	     /* horizontal dot density */
	UWORD	ped_YDotsInch;	     /* vertical dot density */
	char	***ped_Commands;     /* printer text command table */
	int	(*ped_DoSpecial)(void);  /* special command handler */
	int	(*ped_Render)(void);     /* raster render function */
	LONG	ped_TimeoutSecs;     /* good write timeout */

	/* the following only exists if the segment version is >= 33 */

	char	**ped_8BitChars;     /* conv. strings for the extended font */
	LONG	ped_PrintMode;	     /* set if text printed, otherwise 0 */

	/* the following only exists if the segment version is >= 34 */
	/* ptr to conversion function for all chars */

	int	(*ped_ConvFunc)(void);
	ULONG	ped_MarginXDots; 	/* 
					left unprintable margin in 
					number of printer dots 
					*/
	ULONG	ped_MarginYDots;	/* top unprintable margin */
};

struct PreferencesTP4 
	{
	struct Preferences p;	/* Die bisherigen Preferences */
	UWORD pd_PWaitEnabled;	/* Liegt in der Device Struktur da... */
	UWORD Brightness;	/* Ab hier eigentlich pd_Stack */
	UWORD Contrast;		/* Brightness, Contrast Wertebereich 50..200 */
	UWORD Gamma;		/* Wertebereich 20..500 */
	UBYTE GfxTop;		/* oberer Rand beim Grafikdruck in 1/10 Zoll */
	UBYTE GfxFF;		/* Formfeed Flag 1 => FF */
	UWORD Preview;		/* to be defined */
	UBYTE Tray;		/* ------------------ */
	UBYTE Quality;
	UBYTE TxtTop;
	UBYTE Poster;		/* fr weitere Parameter */
	UBYTE Medium;
	UBYTE Copies;
	ULONG FontID;
	ULONG FontSizeID;
	ULONG TextColor;
	UBYTE LOffsRest;
	UBYTE TOffsRest;
	UBYTE Pars[10];
	ULONG Sets[10];
	ULONG MenuSeg;
	UBYTE *MatchTable;
	UBYTE *GammaSum;
	UBYTE **GammaTables;
	UWORD SeparationFlags;
	UBYTE TrueMatch;
	UBYTE Smoothing;
	UBYTE Mirror;
	UBYTE Pad;
	ULONG (* colconv24)(ULONG red, ULONG green, ULONG blue);
			/* Farbkonvertierungsroutine R/G/B => CMY */
	APTR  GfxFont;
};

typedef struct PreferencesTP4 turboprefs ;
